import type { File } from "@babel/types";
import type { LaxPartial } from "@samual/lib";
type MinifyOptions = {
    /** 11 a-z 0-9 characters */
    uniqueID: string;
    /** whether to mangle function and class names (defaults to `false`) */
    mangleNames: boolean;
    /**
     * when set to `true` forces use of quine cheats
     *
     * when set to `false` forces quine cheats not to be used
     *
     * when left unset or set to `undefined`, automatically uses or doesn't use quine cheats based on character count
     */
    forceQuineCheats: boolean;
    /** the comment inserted after the function signature */
    autocomplete: string;
};
/**
 * @param file babel ast node representing a file containing transformed code
 * @param options {@link MinifyOptions details}
 */
export declare const minify: (file: File, { uniqueID, mangleNames, forceQuineCheats, autocomplete }?: LaxPartial<MinifyOptions>) => Promise<string>;
export default minify;
