import type { File } from "@babel/types";
export type TransformOptions = {
    /** 11 a-z 0-9 characters */
    uniqueID: string;
    /** the user going to be hosting this script (or set to `true` if not yet known) */
    scriptUser: string | true;
    /** the name of this script (or set to `true` if not yet known) */
    scriptName: string | true;
    seclevel: number;
};
/**
 * transform a given babel `File` to be hackmud compatible
 *
 * (returned File will need `postprocess()`ing)
 *
 * @param file babel ast node representing a file containing preprocessed code
 * @param sourceCode the original untouched source code
 * @param options {@link TransformOptions details}
 */
export declare const transform: (file: File, sourceCode: string, { uniqueID, scriptUser, scriptName, seclevel }?: Partial<TransformOptions>) => {
    file: File;
    seclevel: number;
};
export default transform;
