import { copyFilePersistent } from '@samual/lib/copyFilePersistent';
import { resolve } from 'path';

/**
 * Copies script from hackmud to local source folder.
 *
 * @param sourceFolderPath path to folder containing source files
 * @param hackmudPath path to hackmud directory
 * @param script to pull in `user.name` format
 */
const pull = async (sourceFolderPath, hackmudPath, script) => {
  const [user, name] = script.split(`.`);
  if (!user || !name) throw new Error(`\`script\` argument must be in "user.name" format`);
  await copyFilePersistent(resolve(hackmudPath, user, `scripts`, `${name}.js`), resolve(sourceFolderPath, user, `${name}.js`));
};

export { pull as default, pull };
