import type { LaxPartial } from "@samual/lib";
import type { PushOptions } from "./push";
export type WatchOptions = PushOptions & {
    /**
     * if provided, will write typescript type declarations for all the scripts on every change detected
     *
     * writing the type declarations enables interscript type checking and autocompletetes for the args
     */
    typeDeclarationPath: string;
    onReady: () => void;
};
/**
 * Watches target file or folder for updates and builds and pushes updated file.
 *
 * @param sourceDirectory path to folder containing source files
 * @param hackmudDirectory path to hackmud directory
 * @param options {@link WatchOptions details} and {@link PushOptions more details}
 */
export declare const watch: (sourceDirectory: string, hackmudDirectory: string, { scripts, onPush, minify, mangleNames, typeDeclarationPath: typeDeclarationPath_, onReady, forceQuineCheats }?: LaxPartial<WatchOptions>) => Promise<void>;
export default watch;
